/*
    Copyright (C) 2007 by Michael Dale Long
  
    This file is part of DuSTED.
  
    DuSTED is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.
  
    DuSTED is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.
  
    You should have received a copy of the GNU General Public License
    along with DuSTED.  If not, see <http://www.gnu.org/licenses/>.
*/

#ifndef DUSTED_H
#define DUSTED_H

#include <new>
#include <cstdlib>
#include "log.h"

// Define application version number
#define VERSION "0.4"

// Default string buffer size (these can be allocated on the stack)
#define BUFFER_SIZE 32

// LogFatal buffer.  Not allocated on stack.
#define FATAL_BUFFER_SIZE 4096

// Save info
#define SRAM_SIGNATURE "DSED"
#define SRAM_VERSION 1

// Override new to trap failed allocations
void *operator new(size_t size);
void operator delete(void *ptr);
//TODO write safe malloc/free routines

#ifndef NDS_SIMULATOR
// These break emulators, but disabling it will probably overflow the irq stack anyways
//# define SYSTEMMODE_INTERRUPTS
#endif

// Widget class IDs
#define CID_WIDGET 0
#define CID_CONTAINER 1
#define CID_WINDOW 2
#define CID_CANVAS 3
#define CID_PALETTE 4

// Application specific CIDs
#define CID_TILEEDITORWINDOW 0x1000

#endif // ! DUSTED_H

