/*
    Copyright (C) 2007 by Michael Dale Long
  
    This file is part of DuSTED.
  
    DuSTED is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.
  
    DuSTED is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.
  
    You should have received a copy of the GNU General Public License
    along with DuSTED.  If not, see <http://www.gnu.org/licenses/>.
*/

#ifndef TILEWIN_H
#define TILEWIN_H

#include "window.h"
#include "undo.h"

class Palette;
class Canvas;

#define NUM_CANVAS 9
#define MAX_TILES 126

class TileEditorWindow : public Window {
	WIDGET_DECL(TileEditorWindow);

public:
	// The palette widget
	Palette *mPaletteWidget;
	// The action handler for undo/redo
	ActionHandler mActions;
	// The canvas widgets
	Canvas *mCanvas[NUM_CANVAS];
	// Canvas mode (0 = single tile, 1 = tile borders, 2 = four tiles, 3 = nine tiles)
	uint16 mMode;
	// Tile mode (sub view, 0 = console, 1 = non-repeating, 2 = repeating)
	uint16 mSubView;
	bool mUpdateSubView;

	virtual void Init(void);
	virtual void Tick(void);
	virtual void Render(void);

	inline void UpdateSubView(void) { if (mSubView) { mUpdateSubView = true; } }
};

#endif // ! TILEWIN_H

