/*
    Copyright (C) 2007 by Michael Dale Long
  
    This file is part of DuSTED.
  
    DuSTED is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.
  
    DuSTED is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.
  
    You should have received a copy of the GNU General Public License
    along with DuSTED.  If not, see <http://www.gnu.org/licenses/>.
*/

#include <nds.h>
#include "dusted.h"
#include "engine.h"
#include "log.h"
#include "tilewin.h"

#ifdef NDS_SIMULATOR
extern "C" int arm9_main_func(void *data) {
	simInitThread(data);
#else
int main(void) {
#endif

	// Allocate the system engine
	gEngine = new Engine();

	// Initialize the engine
	gEngine->Init();

	// Allocate the application window and initialize it
	Window *app = new TileEditorWindow;
	app->Init();

	// Put it on the focus stack
	gEngine->mFocusStack.Push(app);

	// Run the main loop
	gEngine->Loop();

	// Should never reach here
	LogFatal("Engine left main loop.\n");
	return 0;
}

